#include "article.h"
#include "seller.h"
#include "utils.h"

#include <iomanip>
#include <sstream>

Article::Article(int price) : m_price(price) {}

void Article::setArticleNo(int articleNo) { m_articleNo = articleNo; }

void Article::setPrice(int price) { m_price = price; }

void Article::setDescription(const std::string &description) { m_description = description; }

void Article::setSale(Sale *salePtr) { m_salePtr = salePtr; }

void Article::setSeller(Seller *sellerPtr) { m_sellerPtr = sellerPtr; }

bool Article::isSold() { return m_salePtr ? true : false; }

std::string Article::getDescription() { return m_description; }

Seller *Article::getSeller() { return m_sellerPtr; }
Sale *Article::getSale() { return m_salePtr; }

int Article::getPrice() const { return m_price; }

std::string Article::getPriceAsString() const { return formatCentAsEuroString(m_price); }

int Article::getArticleNo() const { return m_articleNo; }

std::string Article::getCompleteArticleNo() const
{
    std::stringstream artNoStream;
    artNoStream << m_sourceNo << "K" << std::setfill('0') << std::setw(5) << m_articleNo;
    return artNoStream.str();
}
